diaryControllers.controller('ActionScreenCtrl', function ($filter,HomeService, $scope,ConfirmModalService, ActionFactory, $uibModal,$state,RequestTypeDefinitions) {
    
    var actionStatus = {};
    $scope.driverEquipment = {};
    $scope.selectedRow = {};
    
    HomeService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;
    });
    
    $scope.selectedActionEntity = function (rowEntity) {
        console.log("this is the action");
        console.log(rowEntity);
        $scope.contextMenuEntityAction = rowEntity.action;
        $scope.selectedRow = rowEntity;
    };
    
    $scope.isActionSelected = function (rowEntity) {
         
        if ($scope.contextMenuEntityAction == null)
            return false;
        return $scope.contextMenuEntityAction.id === rowEntity.action.id;
    };
    
    //$scope.diaryUrl = ClientConfig.route('templates/driversactions/actionScreen.html');
    $scope.changeDriver = function(){
                var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'templates/modals/assignDriverModal.html',
                        controller: 'ChangeDriversCtrl',
                        size: 'lg',
                        scope: $scope
                });
                console.log($scope.selectedRow);
    };
    
    $scope.checkboxes = {
        showComplete: false,
        showDateFilter: false
    };
    $scope.driverId = null;
    
     $scope.clearDriverSearch = function (){
        console.log("clearing");
        $scope.driverId = null;
        $scope.filterSelected.employee = undefined;
    }
    
    
     $scope.filterSelected = {};
    $scope.filterSelected.employee = undefined;
    $scope.filterSelected.requestType = {id: 0, description: 'All'};
    $scope.filterSelected.fromDate = new Date();
    $scope.filterSelected.toDate = new Date();
    $scope.filterSelected.assigned = false;
    
    
    $scope.fromDate = new Date();
    $scope.toDate = new Date();
    $scope.driverId = null;
    
    $scope.taskGridOptions = {
        showColumnFooter: true,
        enableHorizontalScrollbar: 0,
        enableVerticalScrollbar: 0,
        rowTemplate: 'templates/jemserinternal/rows/driveractionrowtemplate.html',
        columnDefs: [{field: 'action.requestId', name:'Request Id', type: 'number'},
                {field: 'customerName', name:'Customer Name'},
                {field: 'siteAddress', name:'Site'},
                {field: 'firstItemDescription', name:'First Item'},
                {field: 'documentType', name: 'Document Type'}, //, cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'
                {field: 'documentNumber', name:'Doc Number', type: 'number'},
                {field: 'driverName', name:'Driver'}
        ]
    };
    
    $scope.driverEquipmentGridOptions = {
         columnDefs: [
                {field: 'jemserProductId.cod', name:'COD'},
                {field: 'jemserProductId.description', name:'Equipment'},
                {field: 'qty', name:'Quantity', type: 'number'},
                {field: 'site.address', name:'Site'}                
        ]   
    };
    
    $scope.load = function () {
        console.log("loading the requests");
        
        console.log($scope.filterSelected.employee);
        $scope.loadingRequestSpinner = "glyphicon glyphicon-refresh spinning";
        if ($scope.filterSelected.employee !== undefined) {
            $scope.driverId = $scope.filterSelected.employee.id;
         };
         
         /*if($scope.filterSelected.requestType.length > 1){
             var count = 0;
             
             while (count < $scope.filterSelected.requestType.length)
             {
             $scope.filterSelected.requestTypeIds     
             }
         }*/
        
        
        //if there is an id it was made through the dropdown so convert it to an array
        if($scope.filterSelected.requestType.id != null){
            $scope.filterSelected.requestType = [$scope.filterSelected.requestType.id];
        }
        
        $scope.filterSelected.fromDate.setHours(00);
        $scope.filterSelected.fromDate.setMinutes(00);
        $scope.filterSelected.toDate.setHours(23);
        $scope.filterSelected.toDate.setMinutes(59);
        $scope.complete = $scope.showComplete;
        $scope.filterBean = {
            fromDate: $scope.filterSelected.fromDate,
            toDate: $scope.filterSelected.toDate,
            driverId: $scope.driverId,
            requestTypeId: $scope.filterSelected.requestType,
            showComplete: $scope.checkboxes.showComplete,
            useDate: $scope.checkboxes.showDateFilter
        };

        console.log("Filter BEan");
        console.log($scope.filterBean);

        ActionFactory.actionSearch($scope.filterBean).then(function (actions) {
            
             $scope.actions = actions.data; 
                console.log("this is the actions");
                   console.log($scope.actions);
                      
             
            
            $scope.taskGridOptions.data = $filter('filter')($scope.actions,{ actionType: {id: 2000}},true);
           
            var deliverys = $filter('filter')($scope.actions,{ actionType: {id: 1000}},true);
            var collections = $filter('filter')($scope.actions,{ actionType: {id: 1001}},true);
            var repairs = $filter('filter')($scope.actions,{ actionType: {id: 1003}},true);
            var others = $filter('filter')($scope.actions,{ actionType: {id: 1005}},true);
            var intransit = $filter('filter')($scope.actions,{ actionType: {id: 2000}},true);
            $scope.taskGridOptions.data = [];
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,deliverys);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,collections);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,repairs);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,others);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,intransit);
            $scope.changeRequestType();
            
//            console.log($scope.taskGridOptions.data);
            $scope.loadingRequestSpinner = "";


        });

    };
    
    $scope.changeRequestType = function(){
        $scope.driverEquipmentGridOptions.data = [];
        var requestTypes = RequestTypeDefinitions.get();
        var type = 'NONE';
        switch($scope.driverEquipment.status){
                case 'NONE':
                        break;
                case 'DELIVERY':
                        type = requestTypes.DELIVERY.id;
                        break;
                case 'COLLECTION':
                        type = requestTypes.COLLECTION.id;
                        break;
                default:
                        break;
        }
        $scope.taskGridOptions.data.forEach(function(action){
                action.detailLineBeans.forEach(function(details){
                        if(action.requestType === type)
                                $scope.driverEquipmentGridOptions.data.push(details);
                })
        })
    }
    
    $scope.load();
    
    $scope.failAction = function (action) {
        console.log("failing action");
        
            $scope.selectedAction = action.action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/modals/failactionmodal.html',
                controller: 'failActionModalCtrl',
                size: 'md',
                scope: $scope
            });
        
    };
    
    
    
    
    $scope.actionStatusChange = function (item, actionStatus) {
        console.log(item);
        console.log(actionStatus);
        var modalOptions = {
            closeButtonText: 'Cancel',
            actionButtonText: 'Ok',
            headerText: 'Mark Action ' + actionStatus + ' ?',
            bodyText: 'Are you sure you want to change the status of this action to  ' + actionStatus + '?'
        };

        ConfirmModalService.showModal({}, modalOptions)
                .then(function (result) {
                    // your-custom-logic
                    if (result) {
                        $scope.selectedAction = item.action;
                        
                        $scope.selectedAction.success = true;
                        $scope.selectedAction.dateCompleted = new Date();
                        console.log("going to mark it as complete");
                        console.log($scope.selectedAction);
            HomeService.createAction($scope.selectedAction).then(function (data) {
            console.log("synced");
            console.log(data.data);
            $scope.load();
           
        });
                        /*
                        var requestStatusChangeAction = ActionFactory.buildNewCompletedAction({actionType: {id: requestStatus.actionId},
                            actionPriority: {id: ActionDefinitions.get().priority.high}, actorPersonId: item.employee,
                            acteePersonId: item.contact, createdByPersonId: item.employee, requestId: item.requestId, comment: "Request Status Change"});
                        DiaryService.createAction(requestStatusChangeAction).then(function (data) {
                            $scope.load();
                            console.log("$scope.selectedRequest = ");
                            console.log($scope.selectedRequest);
                              


                        });*/
                    }
                });

    };
    
    
    $scope.completeActionAndCreateReturn = function(contextMenuEntityAction){
        console.log("im running create return");
        HomeService.createReturnFromOffhire(contextMenuEntityAction.requestId).then(function(result){
            if( result.data.status === 'SUCCESS'){
                // complete the driver action.
                //$scope.actionStatusChange(contextMenuEntityAction, 'COMPLETE');
                $scope.selectedAction = contextMenuEntityAction.action;
                $scope.selectedAction.success = true;
                $scope.selectedAction.dateCompleted = new Date();
                HomeService.createAction($scope.selectedAction).then(function (data) {
                    console.log("synced");
                    console.log(data.data);
                    $scope.load();
                });
            }
        });
    };
    
    $scope.backButton = function(){
        console.log(" going back ");
        $state.go("base.hirehome");
    };

});

diaryControllers.controller('ChangeDriversCtrl', function ($scope, $state, HomeService, $q, ActionFactory, ActionDefinitions, RequestStatusDefinitions, uiGridConstants, $uibModal, $uibModalInstance, RequestTypeDefinitions) {

        $scope.alreadyClicked = false;
        $scope.selected = {};
        
        $scope.addDriver = function () {
                if($scope.alreadyClicked){
                        console.log("prevented subsequent requests to assign driver");
                        return true;
                }
                $scope.alreadyClicked = true;
                
                $scope.documentNumber = $scope.selectedRow.documentNumber;
                $scope.documentType = $scope.selectedRow.requestType; // this needs to be a document type eventually but doesnt seem to be used.
                $scope.driver = $scope.selected.actorPersonId.id;
                $scope.responder = $scope.selectedRow.action.responderBusinessEntity.id;
                console.log($scope.documentNumber + " " +$scope.documentType +" " +$scope.driver +" " + $scope.responder );
                HomeService.updateSigCapQueue($scope.documentNumber, $scope.documentType, $scope.driver, $scope.responder).then(function (data) {
                        console.log("the update data is");
                        console.log(data);
                        $scope.load();
//                        console.log($scope.selected);
//                        console.log($scope.selectedRow);
                        $uibModalInstance.close();
                });
                        
        };

        $scope.cancel = function () {
                $uibModalInstance.close();
        };
});